package com.ephesoft.dcma.da.property;

import com.ephesoft.dcma.core.common.DomainProperty;

public enum BatchClassProperty implements DomainProperty {

	ID("id", "id"), IDENTIFIER("identifier", "identifier"), NAME("name", "name"), DESCRIPTION("description", "description"),
	UNCFOLDER("uncFolder", "uncFolder"), VERSION("version", "version"), PRIORITY("priority", "priority"), CURRENTUSERNAME(
			"currentUser", "currentUser"), ENCRYPTIONALGORITHM("encryptionAlgorithm", "encryptionAlgo"), WORKFLOW_NAME("workflowName",
			"workflowName");

	private String property;

	private String uiProperty;

	/**
	 * @param property
	 */
	BatchClassProperty(String property, String uiProperty) {
		this.property = property;
		this.uiProperty = uiProperty;
	}

	/**
	 * @return the property
	 */
	@Override
	public String getProperty() {
		return property;
	}

	public String getUiProperty() {
		return uiProperty;
	}

	public static BatchClassProperty getPropertyByUiProperty(String uiProperty) {
		BatchClassProperty associatedProperty = null;
		if (uiProperty != null && !uiProperty.trim().isEmpty()) {
			BatchClassProperty[] propertiesArray = BatchClassProperty.values();
			for (BatchClassProperty batchClassProperty : propertiesArray) {
				if (uiProperty.equalsIgnoreCase(batchClassProperty.getUiProperty())) {
					associatedProperty = batchClassProperty;
					break;
				}
			}
		}
		return associatedProperty;
	}

	public static BatchClassProperty getPropertyByProperty(String property) {
		BatchClassProperty associatedProperty = null;
		if (property != null && !property.trim().isEmpty()) {
			BatchClassProperty[] propertiesArray = BatchClassProperty.values();
			for (BatchClassProperty batchClassProperty : propertiesArray) {
				if (property.equalsIgnoreCase(batchClassProperty.getProperty())) {
					associatedProperty = batchClassProperty;
					break;
				}
			}
		}
		return associatedProperty;
	}
}
