package com.ephesoft.dcma.da.property;

import com.ephesoft.dcma.core.common.DomainProperty;
import com.ephesoft.dcma.util.EphesoftStringUtil;

/**
 * Enum for batch instance properties used while sorting on the specified property.
 * 
 * @author Ephesoft
 * @version 1.0
 * @see com.ephesoft.dcma.core.common.DomainProperty
 */
public enum BatchInstanceProperty implements DomainProperty {

	ID("id", "id"), PRIORITY("priority", "priority"), REVIEWUSERNAME("reviewUserName", null), VALIDATIONUSERNAME("validationUserName",
			"validationUserName"), STATUS("status", "status"),BATCHIDENTIFIER("identifier", "batchIdentifier"),

	// batch instance screen contains description field of batch class instead of name field.
	BATCHCLASSNAME("batchClass.description", "batchClassName"),

	BATCHNAME("batchName", "batchName"), LASTMODIFIED("lastModified", "lastModified"), CREATIONDATE("creationDate", "importedOn"),
	CURRENTUSERNAME("currentUser", "currentUser");

	private String property;

	private String dtoProperty;

	/**
	 * @param property
	 */
	BatchInstanceProperty(String property, String dtoProperty) {
		this.property = property;
		this.dtoProperty = dtoProperty;
	}

	/**
	 * @return the property
	 */
	@Override
	public String getProperty() {
		return property;
	}

	public static BatchInstanceProperty getDTOProperty(String dtoField) {
		BatchInstanceProperty[] propertyArray = BatchInstanceProperty.values();
		BatchInstanceProperty dtoProperty = null;
		if (!EphesoftStringUtil.isNullOrEmpty(dtoField)) {
			for (BatchInstanceProperty property : propertyArray) {
				if (dtoField.equalsIgnoreCase(property.dtoProperty)) {
					dtoProperty = property;
					break;
				}
			}
		}
		return dtoProperty;
	}
}
